#ifndef _COMMON__H_
#define _COMMON__H_
#define _GNU_SOURCE
#include <assert.h>
#include <rpc/types.h>		/* For HOSTNAME stuff. */
#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include "gvfs.h"
#include "addons.h"
#include "common.h"

GtkWidget *main_window;
GtkWidget *treelist_vbox;
GtkWidget *main_vbox;
GtkWidget *main_menubar;
GtkWidget *main_buttonbar;
GtkWidget *main_hpaned;
GtkWidget *main_treewin;
GtkWidget *main_tree;
GtkWidget *main_listwin;
GtkWidget *main_list;
GtkWidget *main_statusbar;
GtkWidget *main_history_box;
GtkWidget *toolbox_hbox;
GtkWidget *main_toolbox;
gchar *main_titles[] =
{"Filename", "Size", "Permissions", "Date"};
gchar *GFB_stddefs[GFB_LAST_TYPEDEF];
gint main_window_usize_x;
gint main_window_usize_y;
gint main_treewin_usize_x;
gint main_treewin_usize_y;
int IN_ITEM_SELECT = 0;
int IN_MAKE_DIR_LIST = 0;
int IN_TREE_EXPAND = 0;
gint main_window_destroy_handler = 0;
gboolean show_hidden, show_backup;
gchar **argv;
gint argc;
gboolean tree_view = TRUE;
void
append_slash (gchar * path)
{
  int endptr;
  if (path == NULL)
    return;
  endptr = strlen (path);
  if ((char) *(path + endptr - 1) != '/')
    strcat (path, "/");
}

gint
get_widget_width (GtkWidget * widget)
{
  g_return_val_if_fail (widget != NULL, 0);
  g_return_val_if_fail (GTK_IS_WIDGET (widget), 0);

  if (widget->allocation.width >= 2)
    return widget->allocation.width;
  else
    return 0;
}

gint
get_widget_height (GtkWidget * widget)
{
  g_return_val_if_fail (widget != NULL, 0);
  g_return_val_if_fail (GTK_IS_WIDGET (widget), 0);

  if (widget->allocation.width >= 2)
    return widget->allocation.height;
  else
    return 0;
}

gchar *
get_main_window_width ()
{
  gchar *hgc1 = g_malloc0 (8);
  snprintf (hgc1, 7, "%d", get_widget_width (main_window));
  return hgc1;

}

gchar *
get_main_window_height ()
{
  gchar *hgc1 = g_malloc0 (8);
  snprintf (hgc1, 7, "%d", get_widget_height (main_window));
  return hgc1;

}

void
set_main_window_width (gchar * width)
{
  main_window_usize_x = atoi (width);
}

void
set_main_window_height (gchar * height)
{
  main_window_usize_y = atoi (height);
}

gchar *
get_main_treewin_width ()
{
  gchar *hgc1 = g_malloc0 (8);
  main_treewin_usize_x = get_widget_width (main_treewin);
  snprintf (hgc1, 7, "%d", main_treewin_usize_x);
  return hgc1;

}
gchar *
get_main_treewin_height ()
{
  gchar *hgc1 = g_malloc0 (8);
  main_treewin_usize_y = get_widget_height (main_treewin);
  snprintf (hgc1, 7, "%d", main_treewin_usize_y);
  return hgc1;

}

void
set_main_treewin_width (gchar * width)
{
  main_treewin_usize_x = atoi (width);
}

void
set_main_treewin_height (gchar * height)
{
  main_treewin_usize_y = atoi (height);
}

gboolean
is_file (void *stat_info)
{
  return !(S_ISDIR (((struct stat *) (stat_info))->st_mode));
}

gboolean
is_dir (void *stat_info)
{
  return (S_ISDIR (((struct stat *) (stat_info))->st_mode));
}

gboolean
is_hidden (gchar * filename)
{
  if (*filename == '.')
    return TRUE;
  return FALSE;
}

gboolean
is_backup (gchar * filename)
{
  if (*(filename + strlen (filename) - 1) == '~')
    return TRUE;
  return FALSE;
}

gboolean
is_link (void *stat_info)
{
  return (S_ISLNK (((struct stat *) (stat_info))->st_mode));
}

void
read_dir (gchar * path, GList ** dirs, GList ** files)
{
  GList *hGL1 /*Files */ , *hGL2 /* Dirs */ , *hGL3 /* Files' statistics */ ,
   *hGL4 /* Dirs' statistics */ ;
  UniversalItem *hUI1;
  FileInfo *hFI1;
  hGL1 = hGL2 = hGL3 = hGL4 = NULL;
  hUI1 = NULL;
  hFI1 = NULL;
  hGL1 = gvfs_get_x_list (path, is_file, FALSE, &hGL3);
  hGL2 = gvfs_get_x_list (path, is_dir, FALSE, &hGL4);
  while (hGL1 != NULL)
    {
      hUI1 = g_malloc0 (sizeof (UniversalItem));
      hUI1->type = FILE_LIST_FILE;
      hFI1 = g_malloc0 (sizeof (FileInfo));
      hFI1->name = g_malloc0 (PATH_MAX);
      strcpy (hFI1->name, path);
      strcat (hFI1->name, "/");
      strcat (hFI1->name, hGL1->data);
      g_free (hGL1->data);
      memcpy (&(hFI1->info), hGL3->data, sizeof (struct stat));
      g_free (hGL3->data);
      hFI1->selected = TRUE;
      hGL1 = hGL1->next;
      hGL3 = hGL3->next;
      hUI1->data = hFI1;
      *files = g_list_append (*files, hUI1);
    }
  while (hGL2 != NULL)
    {
      hUI1 = g_malloc0 (sizeof (UniversalItem));
      hUI1->type = FILE_LIST_DIR;
      hFI1 = g_malloc0 (sizeof (FileInfo));
      hFI1->name = g_malloc0 (PATH_MAX);
      strcpy (hFI1->name, path);
      if (*(hFI1->name + strlen (hFI1->name) - 1) != '/')
	strcat (hFI1->name, "/");
      strcat (hFI1->name, hGL2->data);
      g_free (hGL2->data);
      memcpy (&(hFI1->info), hGL4->data, sizeof (struct stat));
      g_free (hGL4->data);
      hFI1->selected = TRUE;
      hGL2 = hGL2->next;
      hGL4 = hGL4->next;
      hUI1->data = hFI1;
      *dirs = g_list_append (*dirs, hUI1);
    }
}

void *
copy_fileinfo (void *fileinfo)
{
  FileInfo *hFI2;
  FileInfo *hFI1 = g_malloc0 (sizeof (FileInfo));
  hFI2 = (FileInfo *) fileinfo;
  if (hFI2->name != NULL)
    hFI1->name = g_strdup (hFI2->name);
  else
    hFI1->name = NULL;
  memcpy (&(hFI1->info), &(hFI2->info), sizeof (struct stat));
  hFI1->selected = hFI2->selected;
  return hFI1;
}

void *
copy_universalitem (void *universalitem)
{
  UniversalItem *hUI1 = (UniversalItem *) universalitem;
  UniversalItem *hUI2 = g_malloc0 (sizeof (UniversalItem));
  hUI2->type = hUI1->type;
  hUI2->data = NULL;
  return hUI2;
}

void *
malloc0 (guint size)
{
  void *p;
  if (size == 0)
    return NULL;
  p = malloc (size);
  memset (p, 0, size);
  return p;
}

gchar *
absolutize_name (gchar * filename)
{
  gchar *full_path = g_malloc0 (PATH_MAX);
  if (*filename == '/')
    strcpy (full_path, filename);
  else
    {
      strcpy (full_path, gvfs_get_current_dir ());
      if (*(full_path + strlen (full_path) - 1) != '/')		/* check for trailing slash */
	strcat (full_path, "/");
      strcat (full_path, filename);
    };
  return full_path;
}

void
set_hidden_state (gchar * state)
{
  if (!strcmp (state, "TRUE"))
    show_hidden = TRUE;
  else
    show_hidden = FALSE;
}

gchar *
get_hidden_state (void)
{
  if (!show_hidden)
    return "FALSE";
  return "TRUE";
}

void
set_backup_state (gchar * state)
{
  if (!strcmp (state, "TRUE"))
    show_backup = TRUE;
  else
    show_backup = FALSE;
}

gchar *
get_backup_state (void)
{
  if (!show_backup)
    return "FALSE";
  return "TRUE";
}

gchar *
replace_pattern (gchar * string, gchar * pattern, gchar * replacement)
{
  gchar *hgc2;
  gchar *hgc1 = g_malloc0 (strlen (string) - strlen (pattern) + strlen (replacement) + 1);
  string = g_strdup (string);
  hgc2 = strstr (string, pattern);
  if (hgc2 == NULL)
    {
      g_free (hgc1);
      g_free (string);
      return (strdup (string));
    };
  *hgc2 = '\0';
  strcpy (hgc1, string);
  strcat (hgc1, replacement);
  strcat (hgc1, (gchar *) (hgc2 + strlen (pattern)));
  g_free (string);
  return hgc1;
};

void
gfb_execute(gchar *command)
{
  int pid, status;
  char *argv[4];
  g_return_if_fail(command != NULL);
  debug_out(command);
  pid = fork();
  if (pid == -1)
        return ;
  if (pid == 0)
  {
        argv[0] = "sh";
        argv[1] = "-c";
        argv[2] = command;
        argv[3] = 0;
        execv("/bin/sh", argv);
        exit(127);
  }
}

#endif







